install.sh 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. IS_WSL2=false
  29. KERN=$(uname -r)
  30. case "$KERN" in
  31. *icrosoft*WSL2 | *icrosoft*wsl2) IS_WSL2=true;;
  32. *icrosoft) error "Microsoft WSL1 is not currently supported. Please upgrade to WSL2 with 'wsl --set-version <distro> 2'" ;;
  33. *) ;;
  34. esac
  35. VER_PARAM="${OLLAMA_VERSION:+?version=$OLLAMA_VERSION}"
  36. SUDO=
  37. if [ "$(id -u)" -ne 0 ]; then
  38. # Running as root, no need for sudo
  39. if ! available sudo; then
  40. error "This script requires superuser permissions. Please re-run as root."
  41. fi
  42. SUDO="sudo"
  43. fi
  44. NEEDS=$(require curl awk grep sed tee xargs)
  45. if [ -n "$NEEDS" ]; then
  46. status "ERROR: The following tools are required but missing:"
  47. for NEED in $NEEDS; do
  48. echo " - $NEED"
  49. done
  50. exit 1
  51. fi
  52. for BINDIR in /usr/local/bin /usr/bin /bin; do
  53. echo $PATH | grep -q $BINDIR && break || continue
  54. done
  55. OLLAMA_INSTALL_DIR=$(dirname ${BINDIR})
  56. status "Installing ollama to $OLLAMA_INSTALL_DIR"
  57. $SUDO install -o0 -g0 -m755 -d $BINDIR
  58. $SUDO install -o0 -g0 -m755 -d "$OLLAMA_INSTALL_DIR"
  59. if curl -I --silent --fail --location "https://ollama.com/download/ollama-linux-${ARCH}.tgz${VER_PARAM}" >/dev/null ; then
  60. status "Downloading Linux ${ARCH} bundle"
  61. curl --fail --show-error --location --progress-bar \
  62. "https://ollama.com/download/ollama-linux-${ARCH}.tgz${VER_PARAM}" | \
  63. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  64. BUNDLE=1
  65. if [ "$OLLAMA_INSTALL_DIR/bin/ollama" != "$BINDIR/ollama" ] ; then
  66. status "Making ollama accessible in the PATH in $BINDIR"
  67. $SUDO ln -sf "$OLLAMA_INSTALL_DIR/ollama" "$BINDIR/ollama"
  68. fi
  69. else
  70. status "Downloading Linux ${ARCH} CLI"
  71. curl --fail --show-error --location --progress-bar -o "$TEMP_DIR/ollama"\
  72. "https://ollama.com/download/ollama-linux-${ARCH}${VER_PARAM}"
  73. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $OLLAMA_INSTALL_DIR/ollama
  74. BUNDLE=0
  75. if [ "$OLLAMA_INSTALL_DIR/ollama" != "$BINDIR/ollama" ] ; then
  76. status "Making ollama accessible in the PATH in $BINDIR"
  77. $SUDO ln -sf "$OLLAMA_INSTALL_DIR/ollama" "$BINDIR/ollama"
  78. fi
  79. fi
  80. install_success() {
  81. status 'The Ollama API is now available at 127.0.0.1:11434.'
  82. status 'Install complete. Run "ollama" from the command line.'
  83. }
  84. trap install_success EXIT
  85. # Everything from this point onwards is optional.
  86. configure_systemd() {
  87. if ! id ollama >/dev/null 2>&1; then
  88. status "Creating ollama user..."
  89. $SUDO useradd -r -s /bin/false -U -m -d /usr/share/ollama ollama
  90. fi
  91. if getent group render >/dev/null 2>&1; then
  92. status "Adding ollama user to render group..."
  93. $SUDO usermod -a -G render ollama
  94. fi
  95. if getent group video >/dev/null 2>&1; then
  96. status "Adding ollama user to video group..."
  97. $SUDO usermod -a -G video ollama
  98. fi
  99. status "Adding current user to ollama group..."
  100. $SUDO usermod -a -G ollama $(whoami)
  101. status "Creating ollama systemd service..."
  102. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  103. [Unit]
  104. Description=Ollama Service
  105. After=network-online.target
  106. [Service]
  107. ExecStart=$BINDIR/ollama serve
  108. User=ollama
  109. Group=ollama
  110. Restart=always
  111. RestartSec=3
  112. Environment="PATH=$PATH"
  113. [Install]
  114. WantedBy=default.target
  115. EOF
  116. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  117. case $SYSTEMCTL_RUNNING in
  118. running|degraded)
  119. status "Enabling and starting ollama service..."
  120. $SUDO systemctl daemon-reload
  121. $SUDO systemctl enable ollama
  122. start_service() { $SUDO systemctl restart ollama; }
  123. trap start_service EXIT
  124. ;;
  125. esac
  126. }
  127. if available systemctl; then
  128. configure_systemd
  129. fi
  130. # WSL2 only supports GPUs via nvidia passthrough
  131. # so check for nvidia-smi to determine if GPU is available
  132. if [ "$IS_WSL2" = true ]; then
  133. if available nvidia-smi && [ -n "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  134. status "Nvidia GPU detected."
  135. fi
  136. install_success
  137. exit 0
  138. fi
  139. # Install GPU dependencies on Linux
  140. if ! available lspci && ! available lshw; then
  141. warning "Unable to detect NVIDIA/AMD GPU. Install lspci or lshw to automatically detect and install GPU dependencies."
  142. exit 0
  143. fi
  144. check_gpu() {
  145. # Look for devices based on vendor ID for NVIDIA and AMD
  146. case $1 in
  147. lspci)
  148. case $2 in
  149. nvidia) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  150. amdgpu) available lspci && lspci -d '1002:' | grep -q 'AMD' || return 1 ;;
  151. esac ;;
  152. lshw)
  153. case $2 in
  154. nvidia) available lshw && $SUDO lshw -c display -numeric -disable network | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  155. amdgpu) available lshw && $SUDO lshw -c display -numeric -disable network | grep -q 'vendor: .* \[1002\]' || return 1 ;;
  156. esac ;;
  157. nvidia-smi) available nvidia-smi || return 1 ;;
  158. esac
  159. }
  160. if check_gpu nvidia-smi; then
  161. status "NVIDIA GPU installed."
  162. exit 0
  163. fi
  164. if ! check_gpu lspci nvidia && ! check_gpu lshw nvidia && ! check_gpu lspci amdgpu && ! check_gpu lshw amdgpu; then
  165. install_success
  166. warning "No NVIDIA/AMD GPU detected. Ollama will run in CPU-only mode."
  167. exit 0
  168. fi
  169. if check_gpu lspci amdgpu || check_gpu lshw amdgpu; then
  170. if [ $BUNDLE -ne 0 ]; then
  171. status "Downloading Linux ROCm ${ARCH} bundle"
  172. curl --fail --show-error --location --progress-bar \
  173. "https://ollama.com/download/ollama-linux-${ARCH}-rocm.tgz${VER_PARAM}" | \
  174. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  175. install_success
  176. status "AMD GPU ready."
  177. exit 0
  178. fi
  179. # Look for pre-existing ROCm v6 before downloading the dependencies
  180. for search in "${HIP_PATH:-''}" "${ROCM_PATH:-''}" "/opt/rocm" "/usr/lib64"; do
  181. if [ -n "${search}" ] && [ -e "${search}/libhipblas.so.2" -o -e "${search}/lib/libhipblas.so.2" ]; then
  182. status "Compatible AMD GPU ROCm library detected at ${search}"
  183. install_success
  184. exit 0
  185. fi
  186. done
  187. status "Downloading AMD GPU dependencies..."
  188. $SUDO rm -rf /usr/share/ollama/lib
  189. $SUDO chmod o+x /usr/share/ollama
  190. $SUDO install -o ollama -g ollama -m 755 -d /usr/share/ollama/lib/rocm
  191. curl --fail --show-error --location --progress-bar "https://ollama.com/download/ollama-linux-amd64-rocm.tgz${VER_PARAM}" \
  192. | $SUDO tar zx --owner ollama --group ollama -C /usr/share/ollama/lib/rocm .
  193. install_success
  194. status "AMD GPU ready."
  195. exit 0
  196. fi
  197. CUDA_REPO_ERR_MSG="NVIDIA GPU detected, but your OS and Architecture are not supported by NVIDIA. Please install the CUDA driver manually https://docs.nvidia.com/cuda/cuda-installation-guide-linux/"
  198. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  199. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  200. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  201. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  202. install_cuda_driver_yum() {
  203. status 'Installing NVIDIA repository...'
  204. case $PACKAGE_MANAGER in
  205. yum)
  206. $SUDO $PACKAGE_MANAGER -y install yum-utils
  207. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo" >/dev/null ; then
  208. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo
  209. else
  210. error $CUDA_REPO_ERR_MSG
  211. fi
  212. ;;
  213. dnf)
  214. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo" >/dev/null ; then
  215. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo
  216. else
  217. error $CUDA_REPO_ERR_MSG
  218. fi
  219. ;;
  220. esac
  221. case $1 in
  222. rhel)
  223. status 'Installing EPEL repository...'
  224. # EPEL is required for third-party dependencies such as dkms and libvdpau
  225. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  226. ;;
  227. esac
  228. status 'Installing CUDA driver...'
  229. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  230. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  231. fi
  232. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  233. }
  234. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  235. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  236. install_cuda_driver_apt() {
  237. status 'Installing NVIDIA repository...'
  238. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-keyring_1.1-1_all.deb" >/dev/null ; then
  239. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-keyring_1.1-1_all.deb
  240. else
  241. error $CUDA_REPO_ERR_MSG
  242. fi
  243. case $1 in
  244. debian)
  245. status 'Enabling contrib sources...'
  246. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  247. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  248. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  249. fi
  250. ;;
  251. esac
  252. status 'Installing CUDA driver...'
  253. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  254. $SUDO apt-get update
  255. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  256. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  257. }
  258. if [ ! -f "/etc/os-release" ]; then
  259. error "Unknown distribution. Skipping CUDA installation."
  260. fi
  261. . /etc/os-release
  262. OS_NAME=$ID
  263. OS_VERSION=$VERSION_ID
  264. PACKAGE_MANAGER=
  265. for PACKAGE_MANAGER in dnf yum apt-get; do
  266. if available $PACKAGE_MANAGER; then
  267. break
  268. fi
  269. done
  270. if [ -z "$PACKAGE_MANAGER" ]; then
  271. error "Unknown package manager. Skipping CUDA installation."
  272. fi
  273. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  274. case $OS_NAME in
  275. centos|rhel) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -d '.' -f 1) ;;
  276. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  277. fedora) [ $OS_VERSION -lt '39' ] && install_cuda_driver_yum $OS_NAME $OS_VERSION || install_cuda_driver_yum $OS_NAME '39';;
  278. amzn) install_cuda_driver_yum 'fedora' '37' ;;
  279. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  280. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  281. *) exit ;;
  282. esac
  283. fi
  284. if ! lsmod | grep -q nvidia || ! lsmod | grep -q nvidia_uvm; then
  285. KERNEL_RELEASE="$(uname -r)"
  286. case $OS_NAME in
  287. rocky) $SUDO $PACKAGE_MANAGER -y install kernel-devel kernel-headers ;;
  288. centos|rhel|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  289. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  290. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  291. *) exit ;;
  292. esac
  293. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  294. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  295. $SUDO dkms install $NVIDIA_CUDA_VERSION
  296. fi
  297. if lsmod | grep -q nouveau; then
  298. status 'Reboot to complete NVIDIA CUDA driver install.'
  299. exit 0
  300. fi
  301. $SUDO modprobe nvidia
  302. $SUDO modprobe nvidia_uvm
  303. fi
  304. # make sure the NVIDIA modules are loaded on boot with nvidia-persistenced
  305. if command -v nvidia-persistenced > /dev/null 2>&1; then
  306. $SUDO touch /etc/modules-load.d/nvidia.conf
  307. MODULES="nvidia nvidia-uvm"
  308. for MODULE in $MODULES; do
  309. if ! grep -qxF "$MODULE" /etc/modules-load.d/nvidia.conf; then
  310. echo "$MODULE" | sudo tee -a /etc/modules-load.d/nvidia.conf > /dev/null
  311. fi
  312. done
  313. fi
  314. status "NVIDIA GPU ready."
  315. install_success